"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Executor = void 0;
var wait_1 = require("./wait");
var Executor = /** @class */ (function () {
    function Executor(main, options) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        this.main = main;
        this.options = options;
        this.maxTries = Executor.defaultMaxTries;
        this.timeout = Executor.defaultTimeout;
        this.retryCondition = Executor.defaultRetryCondition;
        this.waiter = Executor.defaultWaiter;
        this.args = args;
        if (options) {
            if (options.maxTries)
                this.maxTries = options.maxTries;
            if (options.timeout)
                this.timeout = options.timeout;
            if (options.retryCondition)
                this.retryCondition = options.retryCondition;
            if (options.waiter)
                this.waiter = options.waiter;
            if (options.beforeTry)
                this.beforeTry = options.beforeTry;
            if (options.afterTry)
                this.afterTry = options.afterTry;
            if (options.beforeWait)
                this.beforeWait = options.beforeWait;
            if (options.afterWait)
                this.afterWait = options.afterWait;
            if (options.doFinally)
                this.doFinally = options.doFinally;
        }
    }
    Executor.prototype.execute = function () {
        return __awaiter(this, void 0, void 0, function () {
            var promises, result, reason_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        promises = [this.tryLoop()];
                        if (this.timeout && this.timeout !== -1)
                            promises.push(this.timer(this.timeout));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 7]);
                        return [4 /*yield*/, Promise.race(promises)];
                    case 2:
                        result = _a.sent();
                        return [2 /*return*/, result];
                    case 3:
                        reason_1 = _a.sent();
                        throw reason_1;
                    case 4:
                        if (!this.doFinally) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.doFinally()];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6: return [7 /*endfinally*/];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    Executor.prototype.tryLoop = function () {
        return __awaiter(this, void 0, void 0, function () {
            var result, tries, reason_2, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        result = undefined;
                        tries = 1;
                        _b.label = 1;
                    case 1:
                        if (!(this.maxTries === -1 || tries <= this.maxTries)) return [3 /*break*/, 20];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 8, , 19]);
                        if (!this.beforeTry) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.beforeTry(tries, result)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4: return [4 /*yield*/, this.main.apply(this, this.args)];
                    case 5:
                        result = _b.sent();
                        if (!this.afterTry) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.afterTry(tries, result)];
                    case 6:
                        _b.sent();
                        _b.label = 7;
                    case 7: return [3 /*break*/, 20];
                    case 8:
                        reason_2 = _b.sent();
                        if (!this.afterTry) return [3 /*break*/, 10];
                        return [4 /*yield*/, this.afterTry(tries, reason_2)];
                    case 9:
                        _b.sent();
                        _b.label = 10;
                    case 10:
                        _a = false
                            || tries === this.maxTries;
                        if (_a) return [3 /*break*/, 12];
                        return [4 /*yield*/, this.retryCondition(tries, reason_2)];
                    case 11:
                        _a = !(_b.sent());
                        _b.label = 12;
                    case 12:
                        if (_a)
                            throw reason_2;
                        if (!this.beforeWait) return [3 /*break*/, 14];
                        return [4 /*yield*/, this.beforeWait(tries, reason_2)];
                    case 13:
                        _b.sent();
                        _b.label = 14;
                    case 14:
                        if (!this.waiter) return [3 /*break*/, 16];
                        return [4 /*yield*/, this.waiter(tries, reason_2)];
                    case 15:
                        _b.sent();
                        _b.label = 16;
                    case 16:
                        if (!this.afterWait) return [3 /*break*/, 18];
                        return [4 /*yield*/, this.afterWait(tries, reason_2)];
                    case 17:
                        _b.sent();
                        _b.label = 18;
                    case 18: return [3 /*break*/, 19];
                    case 19:
                        tries++;
                        return [3 /*break*/, 1];
                    case 20: return [2 /*return*/, result];
                }
            });
        });
    };
    Executor.prototype.timer = function (duration) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, new Promise(function (_, reject) {
                            setTimeout(function () { return reject(new Error("timeout")); }, duration);
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Executor.defaultMaxTries = 5;
    Executor.defaultTimeout = -1;
    Executor.defaultRetryCondition = function () { return true; };
    Executor.defaultWaiter = function (tries) { return wait_1.default(100 * Math.pow(2, tries)); };
    return Executor;
}());
exports.Executor = Executor;
exports.default = Executor;
//# sourceMappingURL=executor.js.map